# bombbomb

Bombbomb - JavaScript client for bombbomb
We make it easy to build relationships using simple videos.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.20679
- Package version: 2.0.20679
- Build date: 2016-09-08T21:05:32.332Z
- Build package: class io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install bombbomb --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var Bombbomb = require('bombbomb');

var defaultClient = Bombbomb.ApiClient.instance;

// Configure OAuth2 access token for authorization: BBOAuth2
var BBOAuth2 = defaultClient.authentications['BBOAuth2'];
BBOAuth2.accessToken = "YOUR ACCESS TOKEN"

var api = new Bombbomb.PromptsApi()

var prompt = new Bombbomb.VideoEmailPrompt(); // {VideoEmailPrompt} The Video Email Prompt to be created


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.createVideoEmailPrompt(prompt, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://api.bombbomb.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Bombbomb.PromptsApi* | [**createVideoEmailPrompt**](docs/PromptsApi.md#createVideoEmailPrompt) | **POST** /prompt | Prompts user to send a video
*Bombbomb.PromptsApi* | [**getVideoEmailPrompt**](docs/PromptsApi.md#getVideoEmailPrompt) | **GET** /prompt/{id} | Gets a prompt
*Bombbomb.PromptsApi* | [**respondToVideoEmailPrompt**](docs/PromptsApi.md#respondToVideoEmailPrompt) | **POST** /prompt/{id}/response | Respond to a prompt
*Bombbomb.TeamsApi* | [**cancelJerichoSend**](docs/TeamsApi.md#cancelJerichoSend) | **DELETE** /team/{teamId}/jericho/{jerichoId} | Cancel a Jericho Send
*Bombbomb.TeamsApi* | [**getClientGroupAssets**](docs/TeamsApi.md#getClientGroupAssets) | **GET** /team/assets/ | Lists team assets
*Bombbomb.TeamsApi* | [**getJerichoSends**](docs/TeamsApi.md#getJerichoSends) | **GET** /team/{teamId}/jericho | List Jericho Sends
*Bombbomb.TeamsApi* | [**getJerichoStats**](docs/TeamsApi.md#getJerichoStats) | **GET** /team/{teamId}/jericho/{jerichoId}/performance | Gets Jericho performance statistics
*Bombbomb.TeamsApi* | [**queueJerichoSend**](docs/TeamsApi.md#queueJerichoSend) | **POST** /team/{teamId}/jericho | Creates a Jericho send.
*Bombbomb.UtilitiesApi* | [**createOAuthClient**](docs/UtilitiesApi.md#createOAuthClient) | **POST** /oauthclient | Create an OAuth Client
*Bombbomb.UtilitiesApi* | [**deleteOAuthClient**](docs/UtilitiesApi.md#deleteOAuthClient) | **DELETE** /oauthclient/{id} | Delete an OAuth Client
*Bombbomb.UtilitiesApi* | [**getOAuthClients**](docs/UtilitiesApi.md#getOAuthClients) | **GET** /oauthclient | Lists OAuth Clients
*Bombbomb.UtilitiesApi* | [**getSpec**](docs/UtilitiesApi.md#getSpec) | **GET** /spec | Describes this api
*Bombbomb.WebhooksApi* | [**addWebHook**](docs/WebhooksApi.md#addWebHook) | **POST** /webhook | Add Webhook
*Bombbomb.WebhooksApi* | [**deleteWebHook**](docs/WebhooksApi.md#deleteWebHook) | **DELETE** /webhook/{hookId} | Deletes Webhook
*Bombbomb.WebhooksApi* | [**getWebHooks**](docs/WebhooksApi.md#getWebHooks) | **GET** /webhook/ | Lists Webhooks
*Bombbomb.WebhooksApi* | [**sendWebhookExample**](docs/WebhooksApi.md#sendWebhookExample) | **POST** /webhook/test | Sends test Webhook


## Documentation for Models

 - [Bombbomb.BBWebHook](docs/BBWebHook.md)
 - [Bombbomb.InlineResponse200](docs/InlineResponse200.md)
 - [Bombbomb.InlineResponse200Items](docs/InlineResponse200Items.md)
 - [Bombbomb.JerichoConfiguration](docs/JerichoConfiguration.md)
 - [Bombbomb.JerichoPerformance](docs/JerichoPerformance.md)
 - [Bombbomb.ModelString](docs/ModelString.md)
 - [Bombbomb.OAuthClient](docs/OAuthClient.md)
 - [Bombbomb.VideoEmailPrompt](docs/VideoEmailPrompt.md)


## Documentation for Authorization


### BBOAuth2

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://app.bombbomb.com/auth/authorize
- **Scopes**: 
  - all:manage: Manage All
  - all:read: Read All
  - email:manage: Manage Email
  - email:read: Read Email
  - video:manage: Manage Video
  - video:read: Read Video
  - contact:manage: Manage Contact
  - contact:read: Read Contact
  - automation:manage: Manage Automation
  - automation:read: Read Automation
  - form:manage: Manage Form
  - form:read: Read Form
  - team:manage: Manage Team
  - team:read: Read Team
  - settings:manage: Manage Settings

