/**
 * BombBomb
 * We make it easy to build relationships using simple videos.
 *
 * OpenAPI spec version: 2.0.20679
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InlineResponse200', 'model/JerichoConfiguration', 'model/JerichoPerformance'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/InlineResponse200'), require('../model/JerichoConfiguration'), require('../model/JerichoPerformance'));
  } else {
    // Browser globals (root is window)
    if (!root.Bombbomb) {
      root.Bombbomb = {};
    }
    root.Bombbomb.TeamsApi = factory(root.Bombbomb.ApiClient, root.Bombbomb.InlineResponse200, root.Bombbomb.JerichoConfiguration, root.Bombbomb.JerichoPerformance);
  }
}(this, function(ApiClient, InlineResponse200, JerichoConfiguration, JerichoPerformance) {
  'use strict';

  /**
   * Teams service.
   * @module api/TeamsApi
   * @version 2.0.20679
   */

  /**
   * Constructs a new TeamsApi. 
   * @alias module:api/TeamsApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the cancelJerichoSend operation.
     * @callback module:api/TeamsApi~cancelJerichoSendCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Cancel a Jericho Send
     * Cancels a scheduled Jericho send from being sent.
     * @param {String} jerichoId ID of the Jericho Job to cancel
     * @param {module:api/TeamsApi~cancelJerichoSendCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.cancelJerichoSend = function(jerichoId, callback) {
      var postBody = null;

      // verify the required parameter 'jerichoId' is set
      if (jerichoId == undefined || jerichoId == null) {
        throw "Missing the required parameter 'jerichoId' when calling cancelJerichoSend";
      }


      var pathParams = {
        'jerichoId': jerichoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['BBOAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/team/{teamId}/jericho/{jerichoId}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getClientGroupAssets operation.
     * @callback module:api/TeamsApi~getClientGroupAssetsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse200} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Lists team assets
     * Returns a collection of assets
     * @param {module:model/String} assetType The type of assets.
     * @param {Object} opts Optional parameters
     * @param {String} opts.teamId The team containing the assets.
     * @param {String} opts.autoTagName The auto tag name containing the assets.
     * @param {String} opts.pageSize The number of items to retrieve in a single db query.
     * @param {String} opts.page Zero-based index of the page of data to retrieve from the db.
     * @param {String} opts.search Search words.
     * @param {module:api/TeamsApi~getClientGroupAssetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse200}
     */
    this.getClientGroupAssets = function(assetType, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'assetType' is set
      if (assetType == undefined || assetType == null) {
        throw "Missing the required parameter 'assetType' when calling getClientGroupAssets";
      }


      var pathParams = {
      };
      var queryParams = {
        'assetType': assetType,
        'teamId': opts['teamId'],
        'autoTagName': opts['autoTagName'],
        'pageSize': opts['pageSize'],
        'page': opts['page'],
        'search': opts['search']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['BBOAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse200;

      return this.apiClient.callApi(
        '/team/assets/', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getJerichoSends operation.
     * @callback module:api/TeamsApi~getJerichoSendsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/JerichoConfiguration>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Jericho Sends
     * Lists Jericho sends, both pending and sent.
     * @param {String} teamId The team whose Jericho sends you wish to see.
     * @param {module:api/TeamsApi~getJerichoSendsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/JerichoConfiguration>}
     */
    this.getJerichoSends = function(teamId, callback) {
      var postBody = null;

      // verify the required parameter 'teamId' is set
      if (teamId == undefined || teamId == null) {
        throw "Missing the required parameter 'teamId' when calling getJerichoSends";
      }


      var pathParams = {
        'teamId': teamId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['BBOAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [JerichoConfiguration];

      return this.apiClient.callApi(
        '/team/{teamId}/jericho', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getJerichoStats operation.
     * @callback module:api/TeamsApi~getJerichoStatsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/JerichoPerformance} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Gets Jericho performance statistics
     * Returns an aggregate view of the performance of a Jericho send
     * @param {String} jerichoId ID of the Jericho job
     * @param {String} teamId ID of team through which Jericho was sent
     * @param {module:api/TeamsApi~getJerichoStatsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/JerichoPerformance}
     */
    this.getJerichoStats = function(jerichoId, teamId, callback) {
      var postBody = null;

      // verify the required parameter 'jerichoId' is set
      if (jerichoId == undefined || jerichoId == null) {
        throw "Missing the required parameter 'jerichoId' when calling getJerichoStats";
      }

      // verify the required parameter 'teamId' is set
      if (teamId == undefined || teamId == null) {
        throw "Missing the required parameter 'teamId' when calling getJerichoStats";
      }


      var pathParams = {
        'jerichoId': jerichoId,
        'teamId': teamId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['BBOAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = JerichoPerformance;

      return this.apiClient.callApi(
        '/team/{teamId}/jericho/{jerichoId}/performance', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the queueJerichoSend operation.
     * @callback module:api/TeamsApi~queueJerichoSendCallback
     * @param {String} error Error message, if any.
     * @param {module:model/JerichoConfiguration} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a Jericho send.
     * Sends email content on behalf of members of a client group. There are two forms this send can take:         Static Email, and Video Prompt. Static emails require only an emailId.         Video Prompts build emails dynamically and require most of the other fields.         You must be an administrator of a Team Account to use this method.
     * @param {module:model/JerichoConfiguration} config JSON representing a Jericho configuration
     * @param {String} teamId The ID of the team.
     * @param {module:api/TeamsApi~queueJerichoSendCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/JerichoConfiguration}
     */
    this.queueJerichoSend = function(config, teamId, callback) {
      var postBody = config;

      // verify the required parameter 'config' is set
      if (config == undefined || config == null) {
        throw "Missing the required parameter 'config' when calling queueJerichoSend";
      }

      // verify the required parameter 'teamId' is set
      if (teamId == undefined || teamId == null) {
        throw "Missing the required parameter 'teamId' when calling queueJerichoSend";
      }


      var pathParams = {
        'teamId': teamId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['BBOAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = JerichoConfiguration;

      return this.apiClient.callApi(
        '/team/{teamId}/jericho', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
