/**
 * BombBomb
 * We make it easy to build relationships using simple videos.
 *
 * OpenAPI spec version: 2.0.20679
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Bombbomb) {
      root.Bombbomb = {};
    }
    root.Bombbomb.BBWebHook = factory(root.Bombbomb.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The BBWebHook model module.
   * @module model/BBWebHook
   * @version 2.0.20679
   */

  /**
   * Constructs a new <code>BBWebHook</code>.
   * The BBWebHook class
   * @alias module:model/BBWebHook
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>BBWebHook</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/BBWebHook} obj Optional instance to populate.
   * @return {module:model/BBWebHook} The populated <code>BBWebHook</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('userId')) {
        obj['userId'] = ApiClient.convertToType(data['userId'], 'String');
      }
      if (data.hasOwnProperty('hookId')) {
        obj['hookId'] = ApiClient.convertToType(data['hookId'], 'Integer');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('isHidden')) {
        obj['isHidden'] = ApiClient.convertToType(data['isHidden'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * The user to whom the webhook belongs
   * @member {String} userId
   */
  exports.prototype['userId'] = undefined;
  /**
   * The id of the hook
   * @member {Integer} hookId
   */
  exports.prototype['hookId'] = undefined;
  /**
   * the url to send hook requests to
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * Whether the hook is displayed to the user
   * @member {Boolean} isHidden
   */
  exports.prototype['isHidden'] = undefined;



  return exports;
}));


