/**
 * BombBomb
 * We make it easy to build relationships using simple videos.
 *
 * OpenAPI spec version: 2.0.20679
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Bombbomb) {
      root.Bombbomb = {};
    }
    root.Bombbomb.OAuthClient = factory(root.Bombbomb.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The OAuthClient model module.
   * @module model/OAuthClient
   * @version 2.0.20679
   */

  /**
   * Constructs a new <code>OAuthClient</code>.
   * @alias module:model/OAuthClient
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>OAuthClient</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/OAuthClient} obj Optional instance to populate.
   * @return {module:model/OAuthClient} The populated <code>OAuthClient</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('identifier')) {
        obj['identifier'] = ApiClient.convertToType(data['identifier'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('clientSecret')) {
        obj['clientSecret'] = ApiClient.convertToType(data['clientSecret'], 'String');
      }
      if (data.hasOwnProperty('grantsAllowed')) {
        obj['grantsAllowed'] = ApiClient.convertToType(data['grantsAllowed'], 'String');
      }
      if (data.hasOwnProperty('owningUserId')) {
        obj['owningUserId'] = ApiClient.convertToType(data['owningUserId'], 'String');
      }
      if (data.hasOwnProperty('redirectUri')) {
        obj['redirectUri'] = ApiClient.convertToType(data['redirectUri'], 'String');
      }
    }
    return obj;
  }

  /**
   * The id of the OAuth Client
   * @member {String} identifier
   */
  exports.prototype['identifier'] = undefined;
  /**
   * The user-facing name of the client. Eg. MyCrm
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * The secret supplied to the OAuth Application
   * @member {String} clientSecret
   */
  exports.prototype['clientSecret'] = undefined;
  /**
   * The grants allowed
   * @member {String} grantsAllowed
   */
  exports.prototype['grantsAllowed'] = undefined;
  /**
   * The user who controls the OAuth App
   * @member {String} owningUserId
   */
  exports.prototype['owningUserId'] = undefined;
  /**
   * Where OAuth authorization sessions are returned to
   * @member {String} redirectUri
   */
  exports.prototype['redirectUri'] = undefined;



  return exports;
}));


